/***************************************************************************
                    configuration_dialog.h  -  description
                             -------------------
    begin                : Sat Feb 9 2001
    copyright            : (C) 2002 by Holger Sattel
    email                : hsattel@rumms.uni-mannheim.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGURATION_DIALOG_H
#define CONFIGURATION_DIALOG_H

#include "prokyon.h"

#include <qtabdialog.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qcheckbox.h>

class Configuration_Dialog : public QTabDialog {
    Q_OBJECT
friend class Configuration;
public: 
	Configuration_Dialog(QWidget *parent, const char *name=0);
	~Configuration_Dialog();
private:
    QLineEdit *db_host_line, *db_database_line, *db_user_line, *db_pass_line, *play_line, *enqueue_line, *burnCD_line;
    QCheckBox *readv2check, *writev2check, *autocheck, *hidecheck, *hddcheck, *smbcheck, *nfscheck;
    QCheckBox *showtooltip, *maxwidthmode, *guirestore;

    QListView *hddlist;
    QPushButton *hddedit, *hddremove;
private slots:
    void slot_selectionChanged();
    void slot_hddadd();
    void slot_hddremove();
    void slot_hddedit();
};

#endif
