#include "prokyon.h"
#include "lvi_track.h"

// debug function only

void dumpdeltamap( QMap<int, QMap<int, DELTAINFO*> > *deltamap ) {  

  qWarning( " ******dumpdeltamap starts here************* ");
  if (deltamap) {
    for ( QMap<int, QMap<int, DELTAINFO*> >::Iterator it1 = deltamap->begin(); it1 != deltamap->end(); ++it1 ) {
//        QString artist( "unknown artist");
//        for( QMap<QString, int>::Iterator it = artistToID.begin(); it != artistToID.end(); ++it) if(it.data() == it1.key()) artist = it.key();
//        qWarning( "deltamap key:%i artist:%s", it1.key(), artist.latin1() ); 
        qWarning( "deltamap key artistID:%i", it1.key() ); 
	// possibly confusion between medium id and medium type????
	//      QString medium;
      for ( QMap<int, DELTAINFO*>::Iterator it2 = it1.data().begin(); it2 != it1.data().end(); ++it2 ) {
//  	switch(it2.key()) {
//  	case MEDIUM_HARDDISK: medium = "MEDIUM_HARDDISK";
//  	  break;
//  	case MEDIUM_CDROM: medium = "MEDIUM_CDROM";
//  	  break;
//  	case MEDIUM_SMB: medium = "MEDIUM_SMB";
//  	  break;
//  	case MEDIUM_NFS: medium = "MEDIUM_NFS";
//  	  break;
//  	case MEDIUM_EXTERN: medium = "MEDIUM_EXTERN";
//  	  break;
//  	default: medium = "unknown medium";
//  	};
	qWarning( "       key mediumID :%d total:%d local:%d name:\"%s\"", 
		  it2.key(), it2.data()->total, it2.data()->local, it2.data()->name.latin1() );

	if ( !it2.data()->deltaalbum->empty() )
	  for( QMap<QString, ALBUMINFO>::Iterator it3 = it2.data()->deltaalbum->begin(); it3 != it2.data()->deltaalbum->end(); ++it3) 
	    qWarning( "            deltaalbum album:\"%s\" local:%i total:%i", it3.data().name.latin1(), it3.data().local, it3.data().total );
	else qWarning("            deltaalbum \"No album\"" );
      };
    }; 
  } else qWarning( " NULL deltamap " );
  qWarning( " **************************************** ");
}

void dumpSelectedItems( QList<QListViewItem>* select )
{
  qWarning( " ******dumpSelectedItems starts here*****" );
  if ( select ) {
    qWarning( "select->count():%d", select->count() );
    for(QListViewItem *curr = select->first(); curr != 0; curr = select->next()) {
      LVI_Track *lvi = dynamic_cast<LVI_Track*>(curr);
      qWarning( "Artist:%s Title:%s", lvi->getArtist().latin1(), lvi->getTitle().latin1() );
    } 
  } else qWarning( "NULL pointer" );
  qWarning( " ****************************************" );
}

void dumpListTracks( QList<TRACK>* alist )
{
  qWarning( " ******dumpListTracks starts here********" );
  if ( alist ) {
    qWarning( "list->count():%d",alist->count() );
    for(TRACK *curr = alist->first(); curr != 0; curr = alist->next()) {
      qWarning( "filename: %s/%s", curr->path.latin1(), curr->filename.latin1() );
    } 
  } else  qWarning( "NULL pointer" );
  qWarning( " ****************************************" );
}

void dumpBaseList( QMap<int, int> *baselist ) {  

  qWarning( " ******dumpbaselist starts here************* ");
  if (baselist) {
    for ( QMap<int,int>::Iterator it1 = baselist->begin(); it1 != baselist->end(); ++it1 ) 
      qWarning( "    artistID:%i count:%i", it1.key(), it1.data() ); 
  } else 
    qWarning( " NULL baselist " );
  qWarning( " **************************************** ");
}

void dumpArtistToID( QMap<QString, int> *artisttoid ) {  

  qWarning( " ******dumpartisttoID starts here************* ");
  if (artisttoid) {
    for ( QMap<QString,int>::Iterator it1 = artisttoid->begin(); it1 != artisttoid->end(); ++it1 )
      qWarning( "     artist:%s ID:%i", it1.key().latin1(), it1.data() ); 
  } else 
    qWarning( " NULL artistID " );
  qWarning( " **************************************** ");
}
